//Generated by DynTFTCodeGen.

{   ResolverAD2S1200DecA7  - Resolver connected to AD2S1200 decoder with CmodA7 board
    Copyright (C) 2021 VCC
    release date: 31 Oct 2021
    author: VCC

    This file is part of ResolverAD2S1200DecA7 project.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included
    in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
    OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}

unit DynTFTGUI;

{$IFNDEF IsMCU}
  {$DEFINE IsDesktop}
{$ENDIF} 

{$IFDEF IsDesktop}
interface
{$ENDIF}

uses
  DynTFTTypes, DynTFTConsts, DynTFTUtils, DynTFTBaseDrawing,
  DynTFTGUIObjects, DynTFTHandlers,

//<DynTFTComponents>
  DynTFTButton,
  DynTFTArrowButton,
  //DynTFTPanel,
  //DynTFTCheckBox,
  DynTFTScrollBar,
  DynTFTItems,
  DynTFTListBox,
  DynTFTLabel,
  //DynTFTRadioButton,
  //DynTFTRadioGroup,
  DynTFTTabButton,
  DynTFTPageControl,
  DynTFTEdit,
  //DynTFTKeyButton,
  //DynTFTVirtualKeyboard,
  DynTFTComboBox,
  DynTFTTrackBar,
  //DynTFTProgressBar,
  DynTFTMessageBox
//<EndOfDynTFTComponents> - Do not remove or modify this line!

  
  {$IFDEF IsDesktop}
    , SysUtils
    {$IFDEF DynTFTFontSupport}, DynTFTFonts {$ENDIF}
  {$ENDIF}

  {$I DynTFTGUIAdditionalUnits.inc}
  ;


procedure DynTFT_GUI_Start;
procedure DrawGUI; //Made available for debugging or various performance improvements. Called by DynTFT_GUI_Start.


implementation


// Project name: ResAD2S1200Dec.dyntftcg //Do not delete or modify this line!

procedure SetScreenActivity;
var
  i: Integer;
begin
  DynTFTAllComponentsContainer[0].Active := True;
  DynTFTAllComponentsContainer[1].Active := True;
  DynTFTAllComponentsContainer[2].Active := False;
  DynTFTAllComponentsContainer[3].Active := False;
  DynTFTAllComponentsContainer[4].Active := False;

  DynTFTAllComponentsContainer[0].ScreenColor := CL_DynTFTScreen_Background;
  DynTFTAllComponentsContainer[1].ScreenColor := CL_DynTFTScreen_Background;
  DynTFTAllComponentsContainer[2].ScreenColor := CL_DynTFTScreen_Background;
  DynTFTAllComponentsContainer[3].ScreenColor := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;
  DynTFTAllComponentsContainer[4].ScreenColor := CL_DynTFTScreen_Background;

  for i := 5 to CDynTFTMaxComponentsContainer - 1 do
    DynTFTAllComponentsContainer[i].Active := False;

  DynTFT_Set_Pen(DynTFTAllComponentsContainer[0].ScreenColor, 1);
  DynTFT_Set_Brush(1, DynTFTAllComponentsContainer[0].ScreenColor, 0, 0, 0, 0);
  DynTFT_Rectangle(0, 0, TFT_DISP_WIDTH, TFT_DISP_HEIGHT);
end;

procedure RegisterAllComponentsEvents;
begin
  DynTFTRegisterButtonEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTButton type: ' + IntToStr(DynTFTGetButtonComponentType));{$ENDIF}
  DynTFTRegisterArrowButtonEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTArrowButton type: ' + IntToStr(DynTFTGetArrowButtonComponentType));{$ENDIF}
  //DynTFTRegisterPanelEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTPanel type: ' + IntToStr(DynTFTGetPanelComponentType));{$ENDIF}
  //DynTFTRegisterCheckBoxEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTCheckBox type: ' + IntToStr(DynTFTGetCheckBoxComponentType));{$ENDIF}
  DynTFTRegisterScrollBarEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTScrollBar type: ' + IntToStr(DynTFTGetScrollBarComponentType));{$ENDIF}
  DynTFTRegisterItemsEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTItems type: ' + IntToStr(DynTFTGetItemsComponentType));{$ENDIF}
  DynTFTRegisterListBoxEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTListBox type: ' + IntToStr(DynTFTGetListBoxComponentType));{$ENDIF}
  DynTFTRegisterLabelEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTLabel type: ' + IntToStr(DynTFTGetLabelComponentType));{$ENDIF}
  //DynTFTRegisterRadioButtonEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTRadioButton type: ' + IntToStr(DynTFTGetRadioButtonComponentType));{$ENDIF}
  //DynTFTRegisterRadioGroupEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTRadioGroup type: ' + IntToStr(DynTFTGetRadioGroupComponentType));{$ENDIF}
  DynTFTRegisterTabButtonEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTTabButton type: ' + IntToStr(DynTFTGetTabButtonComponentType));{$ENDIF}
  DynTFTRegisterPageControlEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTPageControl type: ' + IntToStr(DynTFTGetPageControlComponentType));{$ENDIF}
  DynTFTRegisterEditEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTEdit type: ' + IntToStr(DynTFTGetEditComponentType));{$ENDIF}
  //DynTFTRegisterKeyButtonEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTKeyButton type: ' + IntToStr(DynTFTGetKeyButtonComponentType));{$ENDIF}
  //DynTFTRegisterVirtualKeyboardEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTVirtualKeyboard type: ' + IntToStr(DynTFTGetVirtualKeyboardComponentType));{$ENDIF}
  DynTFTRegisterComboBoxEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTComboBox type: ' + IntToStr(DynTFTGetComboBoxComponentType));{$ENDIF}
  DynTFTRegisterTrackBarEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTTrackBar type: ' + IntToStr(DynTFTGetTrackBarComponentType));{$ENDIF}
  //DynTFTRegisterProgressBarEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTProgressBar type: ' + IntToStr(DynTFTGetProgressBarComponentType));{$ENDIF}
  DynTFTRegisterMessageBoxEvents;        {$IFDEF IsDesktop}DynTFT_DebugConsole('DynTFTMessageBox type: ' + IntToStr(DynTFTGetMessageBoxComponentType));{$ENDIF}
end;

procedure CreateGUI_Screen_0; //Tabs
begin
  PageControl1 := DynTFTPageControl_Create(0, 0, 1, 426, 25);
  {$DEFINE PageControl1_CHorizontal}
  {$IFDEF PageControl1_CVertical}
    PDynTFTPageControl_CreateAllTabButtonsAsVertical(0, 1, 426, 18, 4, PageControl1, CPageControl1_Captions);
  {$ELSE}
    PDynTFTPageControl_CreateAllTabButtonsAsHorizontal(0, 1, 25, 4, CPageControl1_ButtonLefts, CPageControl1_ButtonWidths, PageControl1, CPageControl1_Captions);
  {$ENDIF}
  {$DEFINE PageControl1_Enabled_1}
  {$IFDEF PageControl1_Enabled_0}
    DynTFTDisablePageControl(PageControl1);
  {$ENDIF}
  {$IFDEF IsDesktop}
    PageControl1^.OnChange^ := PageControl1_OnChange;
  {$ELSE}
    PageControl1^.OnChange := @PageControl1_OnChange;
  {$ENDIF}

end;

procedure CreateGUI_Screen_1; //Resolver
begin
  lblPosition := DynTFTLabel_Create(1, 369, 37, 96, 21);
  lblPosition^.Caption := C_lblPosition_Caption; //'Position [Num]'
  lblPosition^.Font_Color := CL_BLUE;

  lblPositionValue := DynTFTLabel_Create(1, 369, 59, 46, 21);
  lblPositionValue^.Caption := '0';
  lblPositionValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00C4FFC4 {$ELSE} $C7F8 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7F8{$ENDIF}  ;

  lblVelocity := DynTFTLabel_Create(1, 369, 118, 96, 21);
  lblVelocity^.Caption := C_lblVelocity_Caption; //'Velocity [Num]'
  lblVelocity^.Font_Color := CL_BLUE;

  lblVelocityValue := DynTFTLabel_Create(1, 369, 139, 46, 21);
  lblVelocityValue^.Caption := '0';
  lblVelocityValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00FFF7C4 {$ELSE} $C7BF {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7BF{$ENDIF}  ;

  cmbExcitationFrequency := DynTFTComboBox_Create(1, 113, 172, 76, 20);
  {$DEFINE cmbExcitationFrequency_Enabled_1}
  {$IFDEF cmbExcitationFrequency_Enabled_0}
    DynTFTDisableComboBox(cmbExcitationFrequency);
  {$ENDIF}
  {$IFNDEF UseExternalItems} 
    cmbExcitationFrequency^.ListBox^.Items^.Strings[0] := C_cmbExcitationFrequency_ListBox_Items_Strings_Item_0; //'10 kHz'
    cmbExcitationFrequency^.ListBox^.Items^.Strings[1] := C_cmbExcitationFrequency_ListBox_Items_Strings_Item_1; //'12 kHz'
    cmbExcitationFrequency^.ListBox^.Items^.Strings[2] := C_cmbExcitationFrequency_ListBox_Items_Strings_Item_2; //'15 kHz'
    cmbExcitationFrequency^.ListBox^.Items^.Strings[3] := C_cmbExcitationFrequency_ListBox_Items_Strings_Item_3; //'20 kHz'
  {$ENDIF} 
  cmbExcitationFrequency^.ListBox^.Items^.ItemIndex := 0;
  cmbExcitationFrequency^.Edit^.Text := C_cmbExcitationFrequency_Edit_Text; //'10 kHz'
  cmbExcitationFrequency^.Editable := False;
  cmbExcitationFrequency^.ListBox^.Items^.Count := 4;
  {$IFDEF ItemsVisibility} 
    cmbExcitationFrequency^.ListBox^.Items^.TotalVisibleCount := 4;
  {$ENDIF} 
  {$IFDEF IsDesktop}
    cmbExcitationFrequency^.OnComboBoxCloseUp^ := cmbExcitationFrequency_OnComboBoxCloseUp;
  {$ELSE}
    cmbExcitationFrequency^.OnComboBoxCloseUp := @cmbExcitationFrequency_OnComboBoxCloseUp;
  {$ENDIF}

  lblExcitationFrequency := DynTFTLabel_Create(1, 3, 172, 102, 20);
  lblExcitationFrequency^.Caption := C_lblExcitationFrequency_Caption; //'Exc Frequency:'
  lblExcitationFrequency^.Font_Color := CL_BLUE;

  lstStatus := DynTFTListBox_Create(1, 201, 211, 210, 62);
  lstStatus^.BaseProps.CanHandleMessages := False;
  {$IFNDEF UseExternalItems} 
    lstStatus^.Items^.Strings[0] := C_lstStatus_Items_Strings_Item_0; //'LOT (Loss of track)'
    lstStatus^.Items^.Strings[1] := C_lstStatus_Items_Strings_Item_1; //'DOS (Degradation of signal)'
    lstStatus^.Items^.Strings[2] := C_lstStatus_Items_Strings_Item_2; //'LOS (Loss of signal)'
  {$ENDIF} 
  lstStatus^.Items^.Count := 3;
  {$IFDEF ItemsVisibility} 
    lstStatus^.Items^.TotalVisibleCount := 3;
  {$ENDIF} 

  lblAD2SStatus := DynTFTLabel_Create(1, 201, 193, 89, 18);
  lblAD2SStatus^.Caption := C_lblAD2SStatus_Caption; //'Status:'
  lblAD2SStatus^.Font_Color := CL_BLUE;

  btnResetAD2S := DynTFTButton_Create(1, 3, 241, 105, 30);
  btnResetAD2S^.Caption := C_btnResetAD2S_Caption; //'Reset AD2S...'
  {$IFDEF IsDesktop}
    btnResetAD2S^.BaseProps.OnMouseUpUser^ := btnResetAD2S_OnMouseUpUser;
  {$ELSE}
    btnResetAD2S^.BaseProps.OnMouseUpUser := @btnResetAD2S_OnMouseUpUser;
  {$ENDIF}

  lblVelocityRPM := DynTFTLabel_Create(1, 201, 118, 96, 21);
  lblVelocityRPM^.Caption := C_lblVelocityRPM_Caption; //'Velocity [RPM]'
  lblVelocityRPM^.Font_Color := CL_BLUE;

  lblVelocityValueRPM := DynTFTLabel_Create(1, 201, 139, 146, 41);
  lblVelocityValueRPM^.Caption := '0';
  lblVelocityValueRPM^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00FFF7C4 {$ELSE} $C7BF {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7BF{$ENDIF}  ;
  {$IFDEF DynTFTFontSupport} 
    lblVelocityValueRPM^.ActiveFont := {$IFDEF IsDesktop} PByte(@CAllFontSettings[1]) {$ELSE} @Verdana29x32_Regular {$ENDIF};
  {$ENDIF} 


  lblPositionDeg := DynTFTLabel_Create(1, 201, 37, 96, 21);
  lblPositionDeg^.Caption := C_lblPositionDeg_Caption; //'Position [Deg]'
  lblPositionDeg^.Font_Color := CL_BLUE;

  lblPositionValueDeg := DynTFTLabel_Create(1, 201, 58, 146, 41);
  lblPositionValueDeg^.Caption := '0';
  lblPositionValueDeg^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00C4FFC4 {$ELSE} $C7F8 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7F8{$ENDIF}  ;
  {$IFDEF DynTFTFontSupport} 
    lblPositionValueDeg^.ActiveFont := {$IFDEF IsDesktop} PByte(@CAllFontSettings[1]) {$ELSE} @Verdana29x32_Regular {$ENDIF};
  {$ENDIF} 


end;

procedure CreateGUI_Screen_2; //Scope
begin
  scrbarTriggerLevel := DynTFTScrollBar_CreateWithDir(2, 88, 247, 142, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTriggerLevel_Enabled_1}
  {$IFDEF scrbarTriggerLevel_Enabled_0}
    DynTFTDisableScrollBar(scrbarTriggerLevel);
  {$ENDIF}
  scrbarTriggerLevel^.Min := 300;
  scrbarTriggerLevel^.Max := 700;
  scrbarTriggerLevel^.Position := 512;
  {$IFDEF IsDesktop}
    scrbarTriggerLevel^.OnScrollBarChange^ := scrbarTriggerLevel_OnScrollBarChange;
  {$ELSE}
    scrbarTriggerLevel^.OnScrollBarChange := @scrbarTriggerLevel_OnScrollBarChange;
  {$ENDIF}

  lblTriggerLevel := DynTFTLabel_Create(2, 1, 247, 54, 21);
  lblTriggerLevel^.Caption := C_lblTriggerLevel_Caption; //'Trigger:'
  lblTriggerLevel^.Font_Color := CL_BLUE;

  lblTriggerLevelValue := DynTFTLabel_Create(2, 56, 247, 28, 19);
  lblTriggerLevelValue^.Caption := C_lblTriggerLevelValue_Caption; //'512'
  lblTriggerLevelValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00C4FFC4 {$ELSE} $C7F8 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7F8{$ENDIF}  ;

  lblAmplification := DynTFTLabel_Create(2, 252, 248, 59, 21);
  lblAmplification^.Caption := C_lblAmplification_Caption; //'ExcAmp:'
  lblAmplification^.Font_Color := CL_BLUE;

  scrbarAmplification := DynTFTScrollBar_CreateWithDir(2, 349, 247, 130, 20, CScrollBarHorizDir);
  {$DEFINE scrbarAmplification_Enabled_1}
  {$IFDEF scrbarAmplification_Enabled_0}
    DynTFTDisableScrollBar(scrbarAmplification);
  {$ENDIF}
  scrbarAmplification^.Max := 255;
  scrbarAmplification^.Position := 77;
  {$IFDEF IsDesktop}
    scrbarAmplification^.OnScrollBarChange^ := scrbarAmplification_OnScrollBarChange;
  {$ELSE}
    scrbarAmplification^.OnScrollBarChange := @scrbarAmplification_OnScrollBarChange;
  {$ENDIF}

  lblAmplificationValue := DynTFTLabel_Create(2, 310, 248, 31, 21);
  lblAmplificationValue^.Caption := '0';
  lblAmplificationValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00C4FFC4 {$ELSE} $C7F8 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7F8{$ENDIF}  ;


  lbllblPositionOnScope := DynTFTLabel_Create(2, 325, 225, 101, 19);
  lbllblPositionOnScope^.Caption := C_lbllblPositionOnScope_Caption; //'Position [Num]:'
  lbllblPositionOnScope^.Font_Color := CL_BLUE;

  lblPositionOnScopeValue := DynTFTLabel_Create(2, 434, 225, 46, 19);
  lblPositionOnScopeValue^.Caption := '0';
  lblPositionOnScopeValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00C4FFC4 {$ELSE} $C7F8 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$C7F8{$ENDIF}  ;
end;

procedure CreateGUI_Screen_3; //Timings
begin
  lblTimingsInfo1 := DynTFTLabel_Create(3, 3, 247, 88, 21);
  lblTimingsInfo1^.Caption := C_lblTimingsInfo1_Caption; //'Timings from'
  lblTimingsInfo1^.Color := CL_BLUE;
  lblTimingsInfo1^.Font_Color := CL_YELLOW;

  scrbarTiming_SampleOn0 := DynTFTScrollBar_CreateWithDir(3, 184, 48, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_SampleOn0_Enabled_1}
  {$IFDEF scrbarTiming_SampleOn0_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_SampleOn0);
  {$ENDIF}
  scrbarTiming_SampleOn0^.Min := 10;
  scrbarTiming_SampleOn0^.Max := 255;
  scrbarTiming_SampleOn0^.Position := 31;
  {$IFDEF IsDesktop}
    scrbarTiming_SampleOn0^.OnScrollBarChange^ := scrbarTiming_SampleOn0_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_SampleOn0^.OnScrollBarChange := @scrbarTiming_SampleOn0_OnScrollBarChange;
  {$ENDIF}

  scrbarTiming_RDCS0_ForPos := DynTFTScrollBar_CreateWithDir(3, 184, 77, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_RDCS0_ForPos_Enabled_1}
  {$IFDEF scrbarTiming_RDCS0_ForPos_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_RDCS0_ForPos);
  {$ENDIF}
  scrbarTiming_RDCS0_ForPos^.Min := 10;
  scrbarTiming_RDCS0_ForPos^.Max := 255;
  scrbarTiming_RDCS0_ForPos^.Position := 81;
  {$IFDEF IsDesktop}
    scrbarTiming_RDCS0_ForPos^.OnScrollBarChange^ := scrbarTiming_RDCS0_ForPos_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_RDCS0_ForPos^.OnScrollBarChange := @scrbarTiming_RDCS0_ForPos_OnScrollBarChange;
  {$ENDIF}

  scrbarTiming_ReadPos := DynTFTScrollBar_CreateWithDir(3, 183, 105, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_ReadPos_Enabled_1}
  {$IFDEF scrbarTiming_ReadPos_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_ReadPos);
  {$ENDIF}
  scrbarTiming_ReadPos^.Min := 10;
  scrbarTiming_ReadPos^.Max := 255;
  scrbarTiming_ReadPos^.Position := 88;
  {$IFDEF IsDesktop}
    scrbarTiming_ReadPos^.OnScrollBarChange^ := scrbarTiming_ReadPos_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_ReadPos^.OnScrollBarChange := @scrbarTiming_ReadPos_OnScrollBarChange;
  {$ENDIF}

  scrbarTiming_RDVELOutOn0_ForVel := DynTFTScrollBar_CreateWithDir(3, 183, 133, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_RDVELOutOn0_ForVel_Enabled_1}
  {$IFDEF scrbarTiming_RDVELOutOn0_ForVel_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_RDVELOutOn0_ForVel);
  {$ENDIF}
  scrbarTiming_RDVELOutOn0_ForVel^.Min := 10;
  scrbarTiming_RDVELOutOn0_ForVel^.Max := 255;
  scrbarTiming_RDVELOutOn0_ForVel^.Position := 92;
  {$IFDEF IsDesktop}
    scrbarTiming_RDVELOutOn0_ForVel^.OnScrollBarChange^ := scrbarTiming_RDVELOutOn0_ForVel_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_RDVELOutOn0_ForVel^.OnScrollBarChange := @scrbarTiming_RDVELOutOn0_ForVel_OnScrollBarChange;
  {$ENDIF}

  scrbarTiming_RDCS0_ForVel := DynTFTScrollBar_CreateWithDir(3, 183, 161, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_RDCS0_ForVel_Enabled_1}
  {$IFDEF scrbarTiming_RDCS0_ForVel_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_RDCS0_ForVel);
  {$ENDIF}
  scrbarTiming_RDCS0_ForVel^.Min := 10;
  scrbarTiming_RDCS0_ForVel^.Max := 255;
  scrbarTiming_RDCS0_ForVel^.Position := 95;
  {$IFDEF IsDesktop}
    scrbarTiming_RDCS0_ForVel^.OnScrollBarChange^ := scrbarTiming_RDCS0_ForVel_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_RDCS0_ForVel^.OnScrollBarChange := @scrbarTiming_RDCS0_ForVel_OnScrollBarChange;
  {$ENDIF}

  scrbarTiming_ReadVel := DynTFTScrollBar_CreateWithDir(3, 183, 190, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_ReadVel_Enabled_1}
  {$IFDEF scrbarTiming_ReadVel_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_ReadVel);
  {$ENDIF}
  scrbarTiming_ReadVel^.Min := 10;
  scrbarTiming_ReadVel^.Max := 255;
  scrbarTiming_ReadVel^.Position := 102;
  {$IFDEF IsDesktop}
    scrbarTiming_ReadVel^.OnScrollBarChange^ := scrbarTiming_ReadVel_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_ReadVel^.OnScrollBarChange := @scrbarTiming_ReadVel_OnScrollBarChange;
  {$ENDIF}

  scrbarTiming_EndCycle := DynTFTScrollBar_CreateWithDir(3, 183, 218, 260, 20, CScrollBarHorizDir);
  {$DEFINE scrbarTiming_EndCycle_Enabled_1}
  {$IFDEF scrbarTiming_EndCycle_Enabled_0}
    DynTFTDisableScrollBar(scrbarTiming_EndCycle);
  {$ENDIF}
  scrbarTiming_EndCycle^.Min := 10;
  scrbarTiming_EndCycle^.Max := 255;
  scrbarTiming_EndCycle^.Position := 107;
  {$IFDEF IsDesktop}
    scrbarTiming_EndCycle^.OnScrollBarChange^ := scrbarTiming_EndCycle_OnScrollBarChange;
  {$ELSE}
    scrbarTiming_EndCycle^.OnScrollBarChange := @scrbarTiming_EndCycle_OnScrollBarChange;
  {$ENDIF}

  lblTimingsInfo2 := DynTFTLabel_Create(3, 87, 247, 152, 21);
  lblTimingsInfo2^.Caption := C_lblTimingsInfo2_Caption; //'AD2S1200 datasheet'
  lblTimingsInfo2^.Color := CL_BLUE;
  lblTimingsInfo2^.Font_Color := CL_YELLOW;

  lblTiming_SampleOn0 := DynTFTLabel_Create(3, 0, 48, 143, 18);
  lblTiming_SampleOn0^.Caption := C_lblTiming_SampleOn0_Caption; //'SampleOn0'
  lblTiming_SampleOn0^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_RDCS0_ForPos := DynTFTLabel_Create(3, 0, 77, 143, 18);
  lblTiming_RDCS0_ForPos^.Caption := C_lblTiming_RDCS0_ForPos_Caption; //'RDCS0_ForPos'
  lblTiming_RDCS0_ForPos^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_ReadPos := DynTFTLabel_Create(3, 0, 105, 143, 18);
  lblTiming_ReadPos^.Caption := C_lblTiming_ReadPos_Caption; //'ReadPos'
  lblTiming_ReadPos^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_RDVELOutOn0_ForVel := DynTFTLabel_Create(3, 0, 133, 143, 18);
  lblTiming_RDVELOutOn0_ForVel^.Caption := C_lblTiming_RDVELOutOn0_ForVel_Caption; //'RDVELOutOn0_ForVel'
  lblTiming_RDVELOutOn0_ForVel^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_RDCS0_ForVel := DynTFTLabel_Create(3, 0, 161, 143, 18);
  lblTiming_RDCS0_ForVel^.Caption := C_lblTiming_RDCS0_ForVel_Caption; //'RDCS0_ForVel'
  lblTiming_RDCS0_ForVel^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_ReadVel := DynTFTLabel_Create(3, 0, 190, 143, 18);
  lblTiming_ReadVel^.Caption := C_lblTiming_ReadVel_Caption; //'ReadVel'
  lblTiming_ReadVel^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_EndCycle := DynTFTLabel_Create(3, 0, 218, 143, 18);
  lblTiming_EndCycle^.Caption := C_lblTiming_EndCycle_Caption; //'EndCycle'
  lblTiming_EndCycle^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblTiming_SampleOn0_Value := DynTFTLabel_Create(3, 144, 48, 35, 18);
  lblTiming_SampleOn0_Value^.Caption := C_lblTiming_SampleOn0_Value_Caption; //'31'
  lblTiming_SampleOn0_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_RDCS0_ForPos_Value := DynTFTLabel_Create(3, 144, 77, 35, 18);
  lblTiming_RDCS0_ForPos_Value^.Caption := C_lblTiming_RDCS0_ForPos_Value_Caption; //'81'
  lblTiming_RDCS0_ForPos_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_ReadPos_Value := DynTFTLabel_Create(3, 144, 105, 35, 18);
  lblTiming_ReadPos_Value^.Caption := C_lblTiming_ReadPos_Value_Caption; //'88'
  lblTiming_ReadPos_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_RDVELOutOn0_ForVel_Value := DynTFTLabel_Create(3, 144, 133, 35, 18);
  lblTiming_RDVELOutOn0_ForVel_Value^.Caption := C_lblTiming_RDVELOutOn0_ForVel_Value_Caption; //'92'
  lblTiming_RDVELOutOn0_ForVel_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_RDCS0_ForVel_Value := DynTFTLabel_Create(3, 144, 161, 35, 18);
  lblTiming_RDCS0_ForVel_Value^.Caption := C_lblTiming_RDCS0_ForVel_Value_Caption; //'95'
  lblTiming_RDCS0_ForVel_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_ReadVel_Value := DynTFTLabel_Create(3, 144, 190, 35, 18);
  lblTiming_ReadVel_Value^.Caption := C_lblTiming_ReadVel_Value_Caption; //'102'
  lblTiming_ReadVel_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_EndCycle_Value := DynTFTLabel_Create(3, 144, 218, 35, 18);
  lblTiming_EndCycle_Value^.Caption := C_lblTiming_EndCycle_Value_Caption; //'107'
  lblTiming_EndCycle_Value^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $0080FF80 {$ELSE} $87F0 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$87F0{$ENDIF}  ;

  lblTiming_SampleOn0_DefaultValue := DynTFTLabel_Create(3, 447, 48, 35, 18);
  lblTiming_SampleOn0_DefaultValue^.Caption := C_lblTiming_SampleOn0_DefaultValue_Caption; //'31'
  lblTiming_SampleOn0_DefaultValue^.Color := CL_YELLOW;

  lblTiming_RDCS0_ForPos_DefaultValue := DynTFTLabel_Create(3, 447, 77, 35, 18);
  lblTiming_RDCS0_ForPos_DefaultValue^.Caption := C_lblTiming_RDCS0_ForPos_DefaultValue_Caption; //'81'
  lblTiming_RDCS0_ForPos_DefaultValue^.Color := CL_YELLOW;

  lblTiming_ReadPos_DefaultValue := DynTFTLabel_Create(3, 447, 105, 35, 18);
  lblTiming_ReadPos_DefaultValue^.Caption := C_lblTiming_ReadPos_DefaultValue_Caption; //'88'
  lblTiming_ReadPos_DefaultValue^.Color := CL_YELLOW;

  lblTiming_RDVELOutOn0_ForVel_DefaultValue := DynTFTLabel_Create(3, 447, 133, 35, 18);
  lblTiming_RDVELOutOn0_ForVel_DefaultValue^.Caption := C_lblTiming_RDVELOutOn0_ForVel_DefaultValue_Caption; //'92'
  lblTiming_RDVELOutOn0_ForVel_DefaultValue^.Color := CL_YELLOW;

  lblTiming_RDCS0_ForVel_DefaultValue := DynTFTLabel_Create(3, 447, 161, 35, 18);
  lblTiming_RDCS0_ForVel_DefaultValue^.Caption := C_lblTiming_RDCS0_ForVel_DefaultValue_Caption; //'95'
  lblTiming_RDCS0_ForVel_DefaultValue^.Color := CL_YELLOW;

  lblTiming_ReadVel_DefaultValue := DynTFTLabel_Create(3, 447, 190, 35, 18);
  lblTiming_ReadVel_DefaultValue^.Caption := C_lblTiming_ReadVel_DefaultValue_Caption; //'102'
  lblTiming_ReadVel_DefaultValue^.Color := CL_YELLOW;

  lblTiming_EndCycle_DefaultValue := DynTFTLabel_Create(3, 447, 218, 35, 18);
  lblTiming_EndCycle_DefaultValue^.Caption := C_lblTiming_EndCycle_DefaultValue_Caption; //'107'
  lblTiming_EndCycle_DefaultValue^.Color := CL_YELLOW;

  lblCurrentTimingValue := DynTFTLabel_Create(3, 144, 30, 93, 16);
  lblCurrentTimingValue^.Caption := C_lblCurrentTimingValue_Caption; //'Current value'
  lblCurrentTimingValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  lblDefaultTimingValue := DynTFTLabel_Create(3, 391, 30, 93, 16);
  lblDefaultTimingValue^.Caption := C_lblDefaultTimingValue_Caption; //'Default value'
  lblDefaultTimingValue^.Color := {$IFDEF DesktopApp_FP}{$IFDEF IsDesktop} $00A4CBFF {$ELSE} $FE54 {$ENDIF}{$ENDIF}  {$IFDEF PIC32App}$FE54{$ENDIF}  ;

  btnResetAllTimings := DynTFTButton_Create(3, 371, 248, 110, 21);
  btnResetAllTimings^.Caption := C_btnResetAllTimings_Caption; //'Reset all'
  {$IFDEF IsDesktop}
    btnResetAllTimings^.BaseProps.OnMouseUpUser^ := btnResetAllTimings_OnMouseUpUser;
  {$ELSE}
    btnResetAllTimings^.BaseProps.OnMouseUpUser := @btnResetAllTimings_OnMouseUpUser;
  {$ENDIF}
end;

procedure CreateGUI_Screen_4; //Settings
begin
  btnLoadSettingsFromFlash := DynTFTButton_Create(4, 41, 55, 150, 30);
  btnLoadSettingsFromFlash^.Caption := C_btnLoadSettingsFromFlash_Caption; //'Load from flash...'
  {$IFDEF IsDesktop}
    btnLoadSettingsFromFlash^.BaseProps.OnMouseUpUser^ := btnLoadSettingsFromFlash_OnMouseUpUser;
  {$ELSE}
    btnLoadSettingsFromFlash^.BaseProps.OnMouseUpUser := @btnLoadSettingsFromFlash_OnMouseUpUser;
  {$ENDIF}

  btnSaveSettingsToFlash := DynTFTButton_Create(4, 220, 55, 150, 30);
  btnSaveSettingsToFlash^.Caption := C_btnSaveSettingsToFlash_Caption; //'Save to flash...'
  {$IFDEF IsDesktop}
    btnSaveSettingsToFlash^.BaseProps.OnMouseUpUser^ := btnSaveSettingsToFlash_OnMouseUpUser;
  {$ELSE}
    btnSaveSettingsToFlash^.BaseProps.OnMouseUpUser := @btnSaveSettingsToFlash_OnMouseUpUser;
  {$ENDIF}
end;


{$IFDEF RTTIREG}
  {$IFDEF IsDesktop} {$IFDEF DesktopApp_FP} // profile: DesktopApp_FP
    function DynTFTLabel_GetPropertyAddress(AComp: PDynTFTBaseComponent; PropertyIndex: Byte): PPtrRec;
    var
      ComponentProperties: array[0..1] of PPtrRec;
      AComponent: PDynTFTLabel;
    begin
      AComponent := PDynTFTLabel(TPtrRec(AComp));
      ComponentProperties[0] := @((AComponent^.Caption{$IFDEF IsDesktop}[1]{$ENDIF}));
      ComponentProperties[1] := @((AComponent^.Font_Color));
      Result := ComponentProperties[PropertyIndex];
    end;

    function DynTFTTrackBar_GetPropertyAddress(AComp: PDynTFTBaseComponent; PropertyIndex: Byte): PPtrRec;
    var
      ComponentProperties: array[0..3] of PPtrRec;
      AComponent: PDynTFTTrackBar;
    begin
      AComponent := PDynTFTTrackBar(TPtrRec(AComp));
      ComponentProperties[0] := @((AComponent^.Min));
      ComponentProperties[1] := @((AComponent^.Max));
      ComponentProperties[2] := @((AComponent^.Position));
      ComponentProperties[3] := {$IFDEF IsDesktop}PPtrRec(TPtr {$ELSE} @( {$ENDIF}(AComponent^.OnTrackBarChange));
      Result := ComponentProperties[PropertyIndex];
    end;

    procedure UpdatePropertyAddress_Registry;
    begin
      DynTFTRegisteredComponents[6].CompGetPropertyAddress := {$IFDEF IsDesktop} DynTFTLabel_GetPropertyAddress {$ELSE} @DynTFTLabel_GetPropertyAddress {$ENDIF};
      DynTFTRegisteredComponents[11].CompGetPropertyAddress := {$IFDEF IsDesktop} DynTFTTrackBar_GetPropertyAddress {$ELSE} @DynTFTTrackBar_GetPropertyAddress {$ENDIF};
    end;
  {$ENDIF} {$ENDIF} // profile: DesktopApp_FP {$IFDEF DesktopApp_FP}

  {$IFDEF IsMCU} {$IFDEF PIC32App} // profile: PIC32App
    function DynTFTLabel_GetPropertyAddress(AComp: PDynTFTBaseComponent; PropertyIndex: Byte): PPtrRec;
    var
      ComponentProperties: array[0..1] of PPtrRec;
      AComponent: PDynTFTLabel;
    begin
      AComponent := PDynTFTLabel(TPtrRec(AComp));
      ComponentProperties[0] := @((AComponent^.Caption{$IFDEF IsDesktop}[1]{$ENDIF}));
      ComponentProperties[1] := @((AComponent^.Font_Color));
      Result := ComponentProperties[PropertyIndex];
    end;

    function DynTFTTrackBar_GetPropertyAddress(AComp: PDynTFTBaseComponent; PropertyIndex: Byte): PPtrRec;
    var
      ComponentProperties: array[0..3] of PPtrRec;
      AComponent: PDynTFTTrackBar;
    begin
      AComponent := PDynTFTTrackBar(TPtrRec(AComp));
      ComponentProperties[0] := @((AComponent^.Min));
      ComponentProperties[1] := @((AComponent^.Max));
      ComponentProperties[2] := @((AComponent^.Position));
      ComponentProperties[3] := {$IFDEF IsDesktop}PPtrRec(TPtr {$ELSE} @( {$ENDIF}(AComponent^.OnTrackBarChange));
      Result := ComponentProperties[PropertyIndex];
    end;

    procedure UpdatePropertyAddress_Registry;
    begin
      DynTFTRegisteredComponents[6].CompGetPropertyAddress := {$IFDEF IsDesktop} DynTFTLabel_GetPropertyAddress {$ELSE} @DynTFTLabel_GetPropertyAddress {$ENDIF};
      DynTFTRegisteredComponents[11].CompGetPropertyAddress := {$IFDEF IsDesktop} DynTFTTrackBar_GetPropertyAddress {$ELSE} @DynTFTTrackBar_GetPropertyAddress {$ENDIF};
    end;
  {$ENDIF} {$ENDIF} // profile: PIC32App {$IFDEF PIC32App}

{$ENDIF} // RTTIREG


procedure DrawGUI;
begin
  {$IFDEF RTTIREG}
    UpdatePropertyAddress_Registry;
    {$IFDEF IsDesktop} {$IFDEF DesktopApp_FP} UpdateAllBinHandlerAddressArray; {$ENDIF} {$ENDIF} // Profile: DesktopApp_FP
    {$IFDEF IsMCU} {$IFDEF PIC32App} UpdateAllBinHandlerAddressArray; {$ENDIF} {$ENDIF} // Profile: PIC32App
  {$ENDIF}

  CreateGUI_Screen_0;
  CreateGUI_Screen_1;
  CreateGUI_Screen_2;
  CreateGUI_Screen_3;
  CreateGUI_Screen_4;

  {$IFDEF RTTIREG}
    ExecuteDesignRTTIInstructions_Create(CDynTFT_InstructionFilter_CreateStartupOnly_BitMask);
  {$ENDIF}

  DynTFTRepaintScreenComponents(0, CREPAINTONSTARTUP, nil);
  DynTFTRepaintScreenComponents(1, CREPAINTONSTARTUP, nil);
end;


{$IFDEF IsDesktop}
  {$IFDEF RTTIREG}
    procedure InitAllBinGUIObjectsToNil;
    var
      i: Integer;
    begin
      for i := 0 to 1 do
        if CAllCreatedBinComponents[i] <> nil then
          CAllCreatedBinComponents[i]^ := nil;
    end;
  {$ENDIF}
{$ENDIF}

  {$IFDEF RTTIREG}
    function CheckIntegerAndPointerSize: Boolean;  // returs True for success
    {$IFDEF IsMCU}
      type
        Pointer = ^Integer;
    {$ENDIF}
    begin
      if SizeOf(Integer) <> C_ProfileIntegerSize then
      begin
        DynTFTDisplayErrorMessage(CRTTIBADINTEGERSIZE, CL_BLUE);
        {$IFDEF IsDesktop} DynTFT_DebugConsole('.................................... ' + CRTTIBADINTEGERSIZE + ' ...  SizeOf(Integer) <> ' + IntToStr(C_ProfileIntegerSize) + '  See profile settings.'); {$ENDIF}
        Result := False;
        Exit;
      end;

      if SizeOf(Pointer) <> C_ProfilePointerSize then
      begin
        DynTFTDisplayErrorMessage(CRTTIBADIPOINTERSIZE, CL_BLUE);
        {$IFDEF IsDesktop} DynTFT_DebugConsole('.................................... ' + CRTTIBADIPOINTERSIZE + ' ...  SizeOf(Pointer) <> ' + IntToStr(C_ProfilePointerSize) + '  See profile settings.'); {$ENDIF}
        Result := False;
        Exit;
      end;

      Result := True;
    end;
  {$ENDIF}


procedure DynTFT_GUI_Start;
begin
  {$IFDEF IsDesktop}
    DynTFT_DebugConsole('Entering DynTFT_GUI_Start');

    {$IFDEF RTTIREG}
      InitAllBinGUIObjectsToNil;
    {$ENDIF}
  {$ENDIF}

  {$IFDEF RTTIREG}
    LinkHandlers;
  {$ENDIF}

  DynTFTInitInputDevStateFlags;

  DynTFTInitComponentTypeRegistration;
  DynTFTInitComponentContainers;    //must be called after InitComponentTypeRegistration
  RegisterAllComponentsEvents;

  SetScreenActivity;

  {$IFDEF RTTIREG}
    if not CheckIntegerAndPointerSize then
      Exit;
  {$ENDIF}

  DrawGUI;
end;

end.
